
//=====================================================================
// Rows
//=====================================================================
var rows = [
    {
        title: 'Cancel',
        run: function(){
            connector.cancel({
                progress: function(e) {
                    UI.info('PROGRESS CANCELSYNC: ' + Utils.formatJSON(e));
                }
            });
        }
    },
    {
        title: 'Set dataCallback',
        run: function(){
            function dataCallback(modelDef, records, erase) {
                UI.info('>>> DataCallback');
                Ti.API.warn(Utils.formatJSON(records));
                connector.batchUpdate(modelDef, records, erase);
            }
            // Here is an example of modifying the query parameters after the connector has been created
            var m = connector.getModelDefinition('contact');
            m.syncOptions.dataCallback = dataCallback;
            m.syncOptions.queryParameters.statecode = 0;
        }
    },
    {
        title: 'Unset dataCallback',
        run: function(){
            var m = connector.getModelDefinition('contact');
            m.syncOptions.dataCallback = null;
        }
    },
    require('tests/login'),
    require('tests/logout')
];

//=====================================================================
// Setup
//=====================================================================
var syncClient = require('appcelerator.syncserver.client');
var Utils = require('utils');
var UI = require('ui');
var dbProxy = Ti.Database;

var host = 'https://example.com';

// To enable certificate pinning, you must include the https module and
// instantiate a securityManager object, which you will pass to the sync
// connector via the creation arguments
var https = require('appcelerator.https'),
    securityManager = https.createX509CertificatePinningSecurityManager([
		{
			url: 'https://example.com',
			serverCertificate: 'example.com.der'
		}
	]);
var connector = syncClient.createSyncConnector({
    name: 'msDynamicsCrm1.0',
    databaseProxy: dbProxy,
    // Override configuration setting
    serverAddress: host,
    securityManager: securityManager
});

UI.init(rows, function(e) {
    rows[e.index].run && rows[e.index].run(UI, Utils, connector);
});

Utils.runSQLScriptWithName('SQLScript.sql', connector);
