function runSQLScriptWithName(name, connector) {
    var file = Ti.Filesystem.getFile(Ti.Filesystem.resourcesDirectory, name);
    if (!file.exists()) {
        Ti.API.error('`'+name+'` not found in Recources');
        return;
    }
    var blob = file.read();
    var readText = blob.text;
    // dispose of file handle & blob.
    file = null;
    blob = null;
    
    var commands = readText.split(';'); // split removes the ';' which will be put back
    var command;
    
    var db = connector.databaseProxy.open(connector.databaseName);
    db.execute('BEGIN;');
    
    for (var i = 0, j = commands.length; i < j; i++) {
        command = commands[i].trim() + ';'; // remove extra white space and add the ';' back
        // do not execute commands that are commented out
        if (command.indexOf('//') > -1 || command.indexOf('#') > -1 || command.indexOf(';') === 0) {
            continue;
        }
        
        db.execute(command);
    }
    
    db.execute('COMMIT;');
    db.close();
}

function formatJSON(evt) {
    return JSON.stringify(evt, function(key, value) {
        if(key === 'source' || key === 'type') {
            return undefined;
        } else {
            return value;
        }
    }, 2);
}

function getPropertyFromTiApp(name) {
    var prop = Ti.App.Properties.getString(name);
    if (!prop) {
        throw new Error('The property "' + name + '" must be set in the tiapp.xml (eg. <property name="' + name + '" type="string">example</property>)');
    }
    return prop;
}

function getSyncUser() {
    return getPropertyFromTiApp('sync-user');
}
function getSyncPassword() {
    return getPropertyFromTiApp('sync-password');
}

exports.runSQLScriptWithName = runSQLScriptWithName;
exports.formatJSON = formatJSON;
exports.getSyncUser = getSyncUser;
exports.getSyncPassword = getSyncPassword;
